//
//  StyleKit.swift
//  GaugeArrow
//
//  Created by Matej Dunik on 10/10/2018.
//  Copyright © 2018 PixelCut. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



import UIKit

public class StyleKit : NSObject {

    //// Drawing Methods

    @objc dynamic public class func drawGauge(pressure: CGFloat = 0.806) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!

        //// Color Declarations
        let strokeColor = UIColor(red: 0.437, green: 0.437, blue: 0.437, alpha: 1.000)
        let highPressureColor = UIColor(red: 0.800, green: 0.320, blue: 0.320, alpha: 1.000)
        let lowPressureColor = UIColor(red: 0.652, green: 0.800, blue: 0.320, alpha: 1.000)

        //// Variable Declarations
        let angle: CGFloat = -240 * pressure
        let limitingColor = pressure > 0.7 ? highPressureColor : lowPressureColor

        //// Outer Frame Drawing
        let outerFramePath = UIBezierPath(ovalIn: CGRect(x: 124, y: 42, width: 100, height: 100))
        UIColor.white.setFill()
        outerFramePath.fill()
        strokeColor.setStroke()
        outerFramePath.lineWidth = 2
        outerFramePath.stroke()


        //// Scale Frame Drawing
        let scaleFramePath = UIBezierPath()
        scaleFramePath.move(to: CGPoint(x: 138.49, y: 112.5))
        scaleFramePath.addCurve(to: CGPoint(x: 153.5, y: 56.49), controlPoint1: CGPoint(x: 127.17, y: 92.89), controlPoint2: CGPoint(x: 133.89, y: 67.81))
        scaleFramePath.addCurve(to: CGPoint(x: 209.51, y: 71.5), controlPoint1: CGPoint(x: 173.11, y: 45.17), controlPoint2: CGPoint(x: 198.19, y: 51.89))
        scaleFramePath.addCurve(to: CGPoint(x: 209.51, y: 112.5), controlPoint1: CGPoint(x: 216.83, y: 84.19), controlPoint2: CGPoint(x: 216.83, y: 99.81))
        scaleFramePath.addLine(to: CGPoint(x: 197.38, y: 105.5))
        scaleFramePath.addCurve(to: CGPoint(x: 197.38, y: 78.5), controlPoint1: CGPoint(x: 202.21, y: 97.15), controlPoint2: CGPoint(x: 202.21, y: 86.85))
        scaleFramePath.addCurve(to: CGPoint(x: 160.5, y: 68.62), controlPoint1: CGPoint(x: 189.93, y: 65.59), controlPoint2: CGPoint(x: 173.41, y: 61.16))
        scaleFramePath.addCurve(to: CGPoint(x: 150.62, y: 105.5), controlPoint1: CGPoint(x: 147.59, y: 76.07), controlPoint2: CGPoint(x: 143.16, y: 92.59))
        scaleFramePath.addLine(to: CGPoint(x: 138.49, y: 112.5))
        scaleFramePath.close()
        strokeColor.setStroke()
        scaleFramePath.lineWidth = 2
        scaleFramePath.stroke()


        //// Display Drawing
        let displayPath = UIBezierPath()
        displayPath.move(to: CGPoint(x: 190.02, y: 129.74))
        displayPath.addCurve(to: CGPoint(x: 157.98, y: 129.74), controlPoint1: CGPoint(x: 179.78, y: 134.09), controlPoint2: CGPoint(x: 168.22, y: 134.09))
        displayPath.addLine(to: CGPoint(x: 160.72, y: 123.3))
        displayPath.addCurve(to: CGPoint(x: 187.28, y: 123.3), controlPoint1: CGPoint(x: 169.21, y: 126.9), controlPoint2: CGPoint(x: 178.79, y: 126.9))
        displayPath.addLine(to: CGPoint(x: 190.02, y: 129.74))
        displayPath.close()
        limitingColor.setFill()
        displayPath.fill()
        strokeColor.setStroke()
        displayPath.lineWidth = 2
        displayPath.stroke()


        //// Bezier Drawing
        let bezierPath = UIBezierPath()
        bezierPath.move(to: CGPoint(x: 174, y: 58))
        bezierPath.addLine(to: CGPoint(x: 174, y: 51))
        bezierPath.move(to: CGPoint(x: 133, y: 92))
        bezierPath.addLine(to: CGPoint(x: 140, y: 92))
        bezierPath.move(to: CGPoint(x: 208, y: 92))
        bezierPath.addLine(to: CGPoint(x: 215, y: 92))
        bezierPath.move(to: CGPoint(x: 198.04, y: 67.96))
        bezierPath.addLine(to: CGPoint(x: 202.99, y: 63.01))
        bezierPath.move(to: CGPoint(x: 145.01, y: 63.01))
        bezierPath.addLine(to: CGPoint(x: 149.96, y: 67.96))
        bezierPath.move(to: CGPoint(x: 205.41, y: 78.99))
        bezierPath.addLine(to: CGPoint(x: 211.88, y: 76.31))
        bezierPath.move(to: CGPoint(x: 136.12, y: 76.31))
        bezierPath.addLine(to: CGPoint(x: 142.59, y: 78.99))
        bezierPath.move(to: CGPoint(x: 158.31, y: 54.12))
        bezierPath.addLine(to: CGPoint(x: 160.99, y: 60.59))
        bezierPath.move(to: CGPoint(x: 187.01, y: 123.41))
        bezierPath.addLine(to: CGPoint(x: 189.69, y: 129.88))
        bezierPath.move(to: CGPoint(x: 189.69, y: 54.12))
        bezierPath.addLine(to: CGPoint(x: 187.01, y: 60.59))
        bezierPath.move(to: CGPoint(x: 160.99, y: 123.41))
        bezierPath.addLine(to: CGPoint(x: 158.31, y: 129.88))
        strokeColor.setStroke()
        bezierPath.lineWidth = 2
        bezierPath.stroke()


        //// Arrow Drawing
        context.saveGState()
        context.translateBy(x: 174, y: 92)
        context.rotate(by: -(angle + 120) * CGFloat.pi/180)

        let arrowPath = UIBezierPath()
        arrowPath.move(to: CGPoint(x: -4, y: 14))
        arrowPath.addLine(to: CGPoint(x: -4, y: 5))
        arrowPath.addLine(to: CGPoint(x: -3, y: -5))
        arrowPath.addLine(to: CGPoint(x: -3, y: -33))
        arrowPath.addLine(to: CGPoint(x: 0, y: -37))
        arrowPath.addLine(to: CGPoint(x: 3, y: -33))
        arrowPath.addLine(to: CGPoint(x: 3, y: -5))
        arrowPath.addLine(to: CGPoint(x: 4, y: 5))
        arrowPath.addLine(to: CGPoint(x: 4, y: 14))
        arrowPath.addLine(to: CGPoint(x: -4, y: 14))
        arrowPath.close()
        strokeColor.setFill()
        arrowPath.fill()
        strokeColor.setStroke()
        arrowPath.lineWidth = 2
        arrowPath.lineJoinStyle = .round
        arrowPath.stroke()

        context.restoreGState()


        //// Center Oval Drawing
        context.saveGState()
        context.translateBy(x: 174, y: 92)

        let centerOvalPath = UIBezierPath(ovalIn: CGRect(x: -6, y: -6, width: 12, height: 12))
        UIColor.white.setFill()
        centerOvalPath.fill()
        strokeColor.setStroke()
        centerOvalPath.lineWidth = 2
        centerOvalPath.stroke()

        context.restoreGState()


        //// LimitOval Drawing
        let limitOvalPath = UIBezierPath(ovalIn: CGRect(x: 204.68, y: 58.4, width: 3, height: 3))
        UIColor.white.setFill()
        limitOvalPath.fill()
        strokeColor.setStroke()
        limitOvalPath.lineWidth = 2
        limitOvalPath.stroke()
    }

}
